#
#  engine
#
#  Playout Daemon for autoradio project
#
#
#  Copyright (C) 2017-2018 Gottfried Gaisbauer <gottfried.gaisbauer@servus.at>
#
#  This file is part of engine.
#
#  engine is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  any later version.
#
#  engine is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with engine. If not, see <http://www.gnu.org/licenses/>.
#

from modules.communication.liquidsoap.client import LiquidSoapClient

class LiquidSoapRecorderClient(LiquidSoapClient):
    # ------------------------------------------------------------------------------------------ #
    def record(self, command, *args):
        if command == "status":
            self.command('record', 'status')

        return self.message

    # ------------------------------------------------------------------------------------------ #
    def recorder_setfilename(self, filename):
        """
        Dateinamen für Aufnahme (Vorproduktion) definieren
        @type    filename: string
        @param   filename: Dateiname - Angabe ohne Verzeichnis und mit Extension
        @rtype:  string
        @return: Die Antwort des Liquidsoap-Servers
        """
        self.command('setfilename', 'record', str(filename))
        return self.message

    # ------------------------------------------------------------------------------------------ #
    def stop_record(self):
        """
        Recorder stoppen
        @rtype:  string
        @return: Die Antwort des Liquidsoap-Servers
        """
        message = self.command('stop', 'record')
        return self.message

    # ------------------------------------------------------------------------------------------ #
    def start_record(self):
        """
        Recorder starten
        @rtype:  string
        @return: Die Antwort des Liquidsoap-Servers
        """
        self.command('start', 'record')
        return self.message

    # ------------------------------------------------------------------------------------------ #
    def recorder_data(self):
        """
        Daten des recorders erhalten
        @rtype:  string
        @return: Die Antwort des Liquidsoap-Servers
        """
        self.command('curfile', 'record')
        return self.message