#!/usr/bin/python3

#
#  engine
#
#  Playout Daemon for autoradio project
#
#
#  Copyright (C) 2017-2018 Gottfried Gaisbauer <gottfried.gaisbauer@servus.at>
#
#  This file is part of engine.
#
#  engine is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  any later version.
#
#  engine is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with engine. If not, see <http://www.gnu.org/licenses/>.
#

from libraries.database.broadcasts import *
import simplejson
import logging
import sqlalchemy

from modules.communication.liquidsoap.communicator import LiquidSoapCommunicator
from modules.monitoring.diskspace_watcher import DiskSpaceWatcher
from libraries.base.config import AuraConfig

def alchemyencoder(obj):
    """JSON encoder function for SQLAlchemy special classes."""
    if isinstance(obj, datetime.date):
        return obj.isoformat()
    elif isinstance(obj, decimal.Decimal):
        return float(obj)
    elif isinstance(obj, sqlalchemy.orm.state.InstanceState):
        return ""
    #elif isinstance(obj, Schedule):
    #    return simplejson.dumps([obj._asdict()], default=alchemyencoder)
    else:
        return str(obj)

def select_with_relationship():
    se = TrackServiceScheduleEntry.select_all()
    for e in se:
        print(e._asdict())

#    programme_as_string = simplejson.dumps([se[0]._asdict()], default=alchemyencoder)
#    print(programme_as_string)

def start_diskspace_watcher():
    config = AuraConfig()
    config.read_config()
    diskspace_watcher = DiskSpaceWatcher(config.config, logging.getLogger("AuraEngine"), LiquidSoapCommunicator(config.config))
    diskspace_watcher.run()

def select_act_programme():
    programme = ScheduleEntry.select_act_programme()
    for p in programme:
        print(p)

# # ## ## ## ## ## # #
# # ENTRY FUNCTION # #
# # ## ## ## ## ## # #
def main():
    #select_with_relationship()
    #start_diskspace_watcher()
    select_act_programme()
# # ## ## ## ## ## ## # #
# # End ENTRY FUNCTION # #
# # ## ## ## ## ## ## # #


if __name__ == "__main__":
    main()

